#include <stdio.h>
#include <stdlib.h>

#include <kqml.h>

int main()
{
	char string[256], string2[256], *buffer;
	int len;
	kqml_message *msg;

	printf("Performative: ");
	fgets(string, sizeof (string), stdin);

	len = strlen (string);
	if (string[len-1] == '\n')
		string[len-1] = '\0';

	msg = kqml_build_msg (string, NULL, NULL, NULL, NULL);

	while (1)
	{
		printf("Field: ");
		fgets(string, sizeof (string), stdin);

		len = strlen (string);
		if (string[len-1] == '\n')
		{
			string[len-1] = '\0';
			len--;
		}
	
		if (len == 0)
			break;

		printf("Value: ");
		fgets(string2, sizeof (string2), stdin);

		len = strlen (string2);
		if (string2[len-1] == '\n')
			string2[len-1] = '\0';
	
		fprintf (stderr, "Calling put with %s %s\n", string, string2);
		kqml_put_field (string, msg, string2, -1);
	}

	kqml_print_msg (stdout, msg);

	buffer = kqml_sprint_msg (NULL, &len, msg);

	printf("%.*s\n", len, buffer);
	kqml_put_embedded_msg (":embed", msg, msg);
	kqml_print_msg (stdout, msg);

	return 0;
}
